<?

$user_vars = array('first_name', 'last_name', 'email', 'state', 'product', 'last_ip', 'active');

class user {

	protected $last_error = '';
	public $serial_id = 0;

	function __construct($serial_id = -1){
		global $dbh, $user_vars;
		if (is_numeric($serial_id) && $serial_id > -1){
			return(user::load_user($serial_id));
		} else {
			return(user::new_user());
		}
	}

	protected function new_user(){
		global $user_vars;
		foreach ($user_vars as $var){
			$this->$var = '';
		}
		$this->serial_id = -1;
		$this->active = 'Y';
	}

	protected function load_user($serial_id){
		global $user_vars, $dbh;
		$sqlline = "select serial_id, last_on, password, date_added ";
		foreach ($user_vars as $var){
			$sqlline .= ", $var";
		}
		$sqlline .= " from user_input where serial_id = ?";
		try {
			$sth = $dbh->prepare($sqlline);
			$sth->execute(array($serial_id));
			$row = $sth->fetch(PDO::FETCH_ASSOC);
			if (!$row['serial_id']){
				$this->last_error = "No Record Found";
				return(false);
			}

			foreach ($row as $key=>$var){
				$this->$key = trim($var);
			}
			return(true);
		} catch (Exception $e) {
			$this->last_error = $e->getMessage();
			return(false);
		}	
	}

	public function last_error(){
		return($this->last_error);
	}

	public function save(){
		global $dbh, $user_vars;
		if ($this->serial_id > 0 && is_numeric($this->serial_id)){
			return(user::update());
		} else {
			return(user::save_new());
		} 
	}

	public function get_password($password){
		if (strlen($password) == 32){
			return($password);
		}
		$pass = $password . SECRET_KEY . $this->serial_id;
		$pass = md5($pass);
		return($pass); 
	}

	private function set_password($password){
		global $dbh;
		try {
			$sqlline = "update user_input set password = ? where serial_id = ?";
			$sth = $dbh->prepare($sqlline);
			$sth->execute(array($password, $this->serial_id));
			$this->password = $password;
		} catch (Exception $e) {
			print_r($e);
		}
	}

	private function save_new(){
		global $dbh, $user_vars;
		$values = '';
		$vars = array();

		$sqlline = "insert into user_input (";
		for ($x=0;$x<sizeof($user_vars);$x++){
			$cur_var = $user_vars[$x];
			if ($x > 0){
				$sqlline .= ', ';
				$values .= ", ";
			}
			$vars[] = $this->$cur_var;
			$sqlline .= $cur_var;
			$values .= "?";
			
		}
		$sqlline .= ") values ($values)";
		try {
			$dbh->beginTransaction();
			$sth = $dbh->prepare($sqlline);
			$sth->execute($vars);
	
			$sqlline = "SELECT DBINFO ('sqlca.sqlerrd1') FROM systables WHERE tabid = 1;";
			$sth = $dbh->query($sqlline);
			$row = $sth->fetch(PDO::FETCH_NUM);
			$this->serial_id = $row[0];

			$password = user::get_password($this->password);
			user::set_password($password);
			$dbh->commit();
			return(true);
		} catch (Exception $e) {
			$this->last_error = $e->getMessage();
			print_r($e);
			$dbh->rollBack();
			return(false);
		}
	}

	private function update(){
		global $user_vars, $dbh;
		$vars = array();
		$sqlline = "update user_input set ";
		for ($x=0;$x<sizeof($user_vars);$x++){
			$cur_var = $user_vars[$x];
			if ($x > 0){ 
				$sqlline .= ", ";
			}
			$sqlline .= "$cur_var = ?";
			$vars[] = $this->$cur_var;
		}
		$sqlline .= " where serial_id = ?";
		$vars[] = $this->serial_id;
		try {
			$dbh->beginTransaction();
			$sth = $dbh->prepare($sqlline);
			$sth->execute($vars);

			if (strlen($this->password) > 0 && strlen($this->password) < 32){
				$password = user::get_password($this->password);
                        	user::set_password($password);
			}
				
			$dbh->commit();
			return(true);
		} catch (Exception $e) {
			$this->last_error = $e->getMessage();
			$dbh->rollBack();
			return(false);
		}
	} 

	public function logon(){	
		global $dbh;
		$vars = array($_SERVER['REMOTE_ADDR'], $this->serial_id);
		try {
			$sqlline = "update user_input set last_on = current year to second, last_ip = ? where serial_id = ?";
			$sth = $dbh->prepare($sqlline);
			$sth->execute($vars);
		} catch (Exception $e) {
			print_r($e);
		}
	}

	public function send_data(){
		$json_data = json_encode($this);
		$url = 'http://'. $_SERVER['SERVER_NAME'] .'/'. dirname($_SERVER['PHP_SELF']) .'/get_request_json.php';
		$ch = curl_init($url);
		curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: text/json'));
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $json_data);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 0);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$ch_result = curl_exec($ch);
		if (curl_errno($ch)) {
		        $this->last_error = curl_error($ch);
			return(false);
    		} else {
			$this->return_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
		        curl_close($ch);
			return(true);
		}
	}
}


		
		
