<?php
/**
 * @package Informix Connection 
 * @version .1 
 */
/*
Plugin Name: Sample Informix Connection
Plugin URI: http://www.advancedatatools.com
Description: This is a sample skeleton plugin to manage Informix database access
Author: Thomas Beebe
Version: .1 
Author URI: http://www.advancedatatools.com/
*/

add_action('admin_menu', 'informix_plugin_menu');

function informix_plugin_menu() {
	add_options_page('Informix Connection', 'Informix', 'manage_options', 'informix_options', 'informix_plugin_options');
}

function informix_plugin_options() {
	if (!current_user_can('manage_options'))  {
		wp_die( __('You do not have sufficient permissions to access this page.') );
	}
	echo '<div class="wrap">';
	if ($_REQUEST['submitme']){ 
		if (save_informix_values()){
			print "<p><font color=red><center>Settings Updated Properly</center></font></p>";
		}
	}
	$host = get_option('INFORMIX_HOST');
        $db = get_option('INFORMIX_DB');
        $informixserver = get_option('INFORMIXSERVER');
        $service = get_option('INFORMIX_SERVICE');
        $login = get_option('INFORMIX_LOGIN');
        $pass = get_option('INFORMIX_PASS');
	$informixdir = get_option('INFORMIXDIR');


	echo '<form name="form1" method="post" action="">';
	echo "<p><table><tr><td>INFORMIXDIR</td><td><input type=text size=40 name=INFORMIXDIR value=\"$informixdir\"></td></tr>
		<tr><td>INFORMIXSERVER</td><td><input type=text size=40 name=INFORMIXSERVER value=\"$informixserver\"></td></tr>
		<tr><td>Server Hostname</td><td><input type=text size=40 name=INFORMIX_HOST value=\"$host\"></td></tr>
		<tr><td>Service</td><td><input type=text size=40 name=INFORMIX_SERVICE value=\"$service\"></td></tr>
		<tr><td>Database</td><td><input type=text size=40 name=INFORMIX_DB value=\"$db\"></td></tr>
		<tr><td>Login</td><td><input type=text size=40 name=INFORMIX_LOGIN value=\"$login\"></td></tr>
		<tr><td>Password</td><td><input type=password size=40 name=pass value=\"\"></td></tr>

	";
	echo '</table></p>';
	echo '<p class="submit">
	<input type="submit" name="submitme" class="button-primary" value="Save Changes" />
	</p>
	</form>
	</div>';
}

function save_informix_values(){
	$vars = array("INFORMIX_HOST", "INFORMIXDIR", "INFORMIXSERVER", "INFORMIX_SERVICE", "INFORMIX_LOGIN", "INFORMIX_DB", 'WP_PREFIX', 'RE_PRIV_KEY', 'RE_PUB_KEY');
	foreach ($vars as $var) 
		if (isset($_REQUEST[$var]))
			update_option($var, $_REQUEST[$var]);
	if ($_REQUEST['pass'])
		update_option('INFORMIX_PASS',$_REQUEST['pass']);
	return(true);
}


function connect_informix() {

        putenv("INFORMIXDIR=". get_option('INFORMIXDIR'));
        putenv("INFORMIXSERVER=". get_option('INFORMIXSERVER'));
        $host = get_option('INFORMIX_HOST');
        $db = get_option('INFORMIX_DB');
        $informixserver = get_option('INFORMIXSERVER');
        $service = get_option('INFORMIX_SERVICE');
        $login = get_option('INFORMIX_LOGIN');
        $pass = get_option('INFORMIX_PASS');
        try {
                $dbh = new PDO("informix:host=$host; service=$service; database=$db; server=$informixserver; protocol=onsoctcp;EnableScrollableCursors=1", "$login", "$pass");
                $dbh->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
		$dbh->setAttribute(PDO::ATTR_CASE, PDO::CASE_LOWER);
                return($dbh);
        } catch (Exception $e) {
                return(false);
        }
}




?>
