<?php
/**
 * @package List Users
 * @version .1
 */
/*
Plugin Name: Sample List Users
Plugin URI: http://www.advancedatatools.com
Description: This is a sample plugin to use the Informix connection to list users
Author: Thomas Beebe
Version: .1
Author URI: http://www.advancedatatools.com/
*/



add_shortcode('ifx_list_users', 'ifx_list_users');

function ifx_list_users($options){
	global $dbh;
	if (!$dbh){
		$dbh = connect_informix();
	}
        $opts = shortcode_atts ( array( 'email' => ''), $options);
        $email = $opts['email'];

	$vars = array();
	if ($email){
		$vars[] = $email;
	}

	$line = "<table border='1'><tr><th>ID</th><th>First Name</th><th>Last Name</th><th>Email</th><th>Last On</th><th>Last IP</th></tr>\n";
	try {
        	$sqlline = "select serial_id, first_name, last_name, email, last_on, last_ip from user_input";
		if ($email) { 
			$sqlline .= " where email = ? ";
		}
		$sqlline .= " order by serial_id";
	        $sth = $dbh->prepare($sqlline);
		$sth->execute($vars);
        	$rows = $sth->fetchAll(PDO::FETCH_OBJ);
	} catch (Exception $e) {
       	 	print "Something Went Wrong<br />";
        	print_r($dbh->errorinfo);
	}

	foreach ($rows as $row){
        	$line .= "<tr><td>$row->serial_id</td><td>$row->first_name</td><td>$row->last_name</td><td>$row->email</td><td>$row->last_on</td><td>$row->last_ip</td></tr>\n";
	}

	$line .= "</table><br />";

        return($line);
}

?>
